(* Title:  "Minisubpbl/600-postcond-NEXT_STEP.sml"
   Author: Walther Neuper 200121
   (c) copyright due to lincense terms.
*)

"----------- Minisubplb/600-postcond-NEXT_STEP.sml -------------------------------------------";
"----------- Minisubplb/600-postcond-NEXT_STEP.sml -------------------------------------------";
"----------- Minisubplb/600-postcond-NEXT_STEP.sml -------------------------------------------";
val fmz = ["equality (x+1=(2::real))", "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]);
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Model_Problem = tac;
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Specify_Theory "Test" = tac;
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Specify_Problem ["sqroot-test", "univariate", "equation", "test"] = tac;
(*[], Met*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Specify_Method ["Test", "squ-equ-test-subpbl1"] = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
 = "([], [], empty, NONE, \n??.empty, ORundef, false, false)"
then () else error "pstate changed after ([], Met)";

(*[1], Frm*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Apply_Method ["Test", "squ-equ-test-subpbl1"] = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
 = "([\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\"], [], empty, NONE, \n??.empty, ORundef, false, true)"
then () else error "pstate changed after ([1], Frm)"; (*this shall be corrected ... \<up> \<up> \<up> : a tac has been found !!!*)

(*[1], Res*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Rewrite_Set "norm_equation" = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
  = "([\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\"], [R, L, R, L, L, R, R], empty, SOME e_e, \nx + 1 + - 1 * 2 = 0, ORundef, true, false)"
then () else error "pstate changed after ([1], Res)"; (*this shall be corrected ............................. \<up> \<up> \<up> *)

(*[2], Res*)val (_, ([(tac, _, _)], _, (pt, p))) =(**) Step.do_next p ((pt, e_pos'), []); val Rewrite_Set "Test_simplify" = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
  = "([\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\"], [R, L, R, L, R, R], empty, SOME e_e, \n- 1 + x = 0, ORundef, true, false)"
then () else error "pstate changed after ([2], Res)"; (*this shall be corrected ................... \<up> \<up> \<up> *)

(*[3], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Subproblem ("Test", ["LINEAR", "univariate", "equation", "test"]) = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
  = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\"], [R, R, D, L, R], empty, NONE, \nSubproblem\n (''Test'',\n  ??.\<^const>String.char.Char ''LINEAR'' ''univariate'' ''equation''\n   ''test''), ORundef, true, false)"
then () else error "pstate changed after ([3], Pbl)";

(*[3], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Model_Problem = tac;
(*[3], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Specify_Theory "Test" = tac;
(*[3], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Specify_Problem ["LINEAR", "univariate", "equation", "test"] = tac;
(*[3], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Specify_Method ["Test", "solve_linear"] = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
  = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\"], [R, R, D, L, R], empty, NONE, \nSubproblem\n (''Test'',\n  ??.\<^const>String.char.Char ''LINEAR'' ''univariate'' ''equation''\n   ''test''), ORundef, true, false)"
then () else error "pstate changed after ([3], Pbl)";

(*[3, 1], Frm*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Apply_Method ["Test", "solve_linear"] = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
 = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\"], [], empty, NONE, \n??.empty, ORundef, false, true)"
then () else error "pstate changed after ([3, 1], Frm)";

(*[3, 1], Res*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Rewrite_Set_Inst (["(''bdv'', x)"], "isolate_bdv") = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
  = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\"], [R, L, R, L, R, L, R], empty, SOME e_e, \nx = 0 + - 1 * - 1, ORundef, true, false)"
then () else error "pstate changed after ([3, 1], Res)";

(*[3, 2], Res*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Rewrite_Set "Test_simplify" = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
  = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\"], [R, L, R, L, R, R], empty, SOME e_e, \nx = 1, ORundef, true, false)"
then () else error "pstate changed after ([3, 2], Res)";

(*[3], Res*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Check_Postcond ["LINEAR", "univariate", "equation", "test"] = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
 = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\"], [R, R, D, L, R], empty, NONE, \n[x = 1], ORundef, true, false)"
then () else error "pstate changed after ([3], Res)";

(*[4], Res*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Check_elementwise "Assumptions" = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
  = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\", \"\n(L_L, [x = 1])\"], [R, R, D, R, D], empty, NONE, \n[x = 1], ORundef, true, false)"
then () else error "pstate changed after ([4], Res)";

(*[], Res*)val ("ok", ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Check_Postcond ["sqroot-test", "univariate", "equation", "test"] = tac;

(*+*)if (get_istate_LI pt p |> the_pstate |> pstate2str)
  = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\", \"\n(L_L, [x = 1])\"], [R, R, D, R, D], empty, NONE, \n[x = 1], ORundef, true, false)"
then () else error "pstate changed after ([], Res)";

val return_me_Check_Postcond_sqroot_test = Step.do_next p ((pt, e_pos'), []);
(*//------------------ step into me_Check_Postcond_sqroot_test -----------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (p, ((pt, e_pos'), []));
  val pIopt = Ctree.get_pblID (pt, ip);
    (*if*) ip = ([], Pos.Res) (*else*);
      val _ = (*case*) tacis (*of*);
      val SOME _ = (*case*) pIopt (*of*);
    (*if*) member op = [Pos.Pbl, Pos.Met] p_  (*else*);

Step_Solve.do_next (pt, ip);
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) = (pt, ip);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
        val thy' = get_obj g_domID pt (par_pblobj pt p);
	      val ((ist, ctxt), sc) = LItool.resume_prog (p,p_) pt;

(*+*)Istate.string_of ctxt ist
 = "Pstate ([\"\n(e_e, - 1 + x = 0)\",\"\n(v_v, x)\",\"\n(L_L, [x = 1])\"], [R,R,D,R,D], empty, NONE, \n[x = 1],"
  ^ " ORundef, true, false)"; (*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~true ok*)

  (*case*) LI.find_next_step sc (pt, pos) ist ctxt (*of*);
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as(pt, (p, _))), (Pstate ist), ctxt)
  = (sc, (pt, pos), ist, ctxt);

  (*case*) scan_to_tactic (prog, (ptp, ctxt)) (Pstate ist) (*of*);
"~~~~~ fun scan_to_tactic , args:"; val ((prog, cc), (Pstate (ist as {path, ...}))) = ((prog, (ptp, ctxt)), (Pstate ist));
  (*if*) path = [] (*else*);

  val Term_Val _ =
           go_scan_up (prog, cc) (trans_scan_up ist);
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...}))
  = ((prog, cc), (trans_scan_up ist));
    (*if*) 1 < length path (*then*);

  val Term_Val _ =
           scan_up pcc (ist |> path_up) (go_up ctxt path sc);
"~~~~~ and scan_up , args:"; val (pcc, ist, (Abs _(*2*))) = (pcc, (ist |> path_up), (go_up ctxt path sc));

  val Term_Val _ =
           go_scan_up pcc ist;
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, _)), (ist as {path, act_arg, found_accept, ...}))
  = (pcc, ist);
    (*if*) 1 < length path (*then*);

  val Term_Val _ =
             go_scan_up pcc ist;
"~~~~~ and scan_up , args:"; val (pcc, ist, (Const (\<^const_name>\<open>Let\<close>(*3*),_) $ _ $ (Abs _)))
  = (pcc, (ist |> path_up), (go_up ctxt path sc));
(*\\------------------ step into me_Check_Postcond_sqroot_test -----------------------------//*)
val ("end-of-calculation", _) = return_me_Check_Postcond_sqroot_test;

(*/--------------------- final test ---------------------------------------------------------\\*)
if pstate2str ist
 = "([\"\n(e_e, - 1 + x = 0)\", \"\n(v_v, x)\", \"\n(L_L, [x = 1])\"], [R, R, D], empty, NONE, \n[x = 1],"^
  " ORundef, true, false)"
then () else error "";

(*ctxt* )Proof_Context.theory_of (Ctree.get_ctxt pt p);( *ctxt CANNOT BE RETRIEVED*)
